
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>MogileFS分布式文件系统 / 憋错料</title>

    <meta name="description" content="MogileFS分布式文件系统 内容概述 1.分布式文件系统介绍 2.CAP理论 3.常见分布式文件系统介绍 4.MogileFS详细介绍 4.1MogileFS组成 4.2MogileFS特性 5.MogileFS实现 5.1 node1配置Mariadb(过程略) 5.2 node1配置tracker 5.3 node2配置storage 5.4  node3配置storage 5.5 配置分布式集群 5.5.1 添加主机 5.5.2 添加设备 5.5.3 定义domain和class 5.6  验证分布式集群 6.Mog">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">MogileFS分布式文件系统</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>内容概述</h1>
<p>1、分布式文件系统介绍</p>
<p>2、CAP理论</p>
<p>3、常见分布式文件系统介绍</p>
<p>4、MogileFS详细介绍</p>
<p>4、1MogileFS组成</p>
<p>4、2MogileFS特性</p>
<p>5、MogileFS实现</p>
<p>5、1 node1配置Mariadb（过程略）</p>
<p>5、2 node1配置tracker</p>
<p>5、3 node2配置storage</p>
<p>5、4&nbsp; node3配置storage</p>
<p>5、5 配置分布式集群</p>
<p>5、5、1 添加主机</p>
<p>5、5、2 添加设备</p>
<p>5、5、3 定义domain和class</p>
<p>5、6&nbsp; 验证分布式集群</p>
<p>6、MogileFS高可用</p>
<p>6、1 node1配置storage</p>
<p>6、2 node2配置tracker</p>
<p>6、3 node3配置tracker</p>
<p>6、4 验证MogileFS高可用</p>
<p>7、nginx反向代理MogileFS</p>
<p>7、1 安装nginx</p>
<p>7、2 设置反向代理</p>
<p>7、3 设置负载均衡</p>
<h1>1、分布式文件系统介绍</h1>
<p><strong>定义：</strong>分布式存储系统是大量普通PC服务器通过Internet互联，对外作为一个整体提供存储服务</p>
<p><strong>特性</strong>：</p>
<p>·&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;可扩展：分布式存储系统可以扩展到几百台至几千台的集群规模，且随着集群规模的增长，系统整体性能表现为线性增长；</p>
<p>·&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;低成本：分布式存储系统的自动容错、自动负载均衡机制使其可以构建在普通PC机之上；另外，线性扩展能力也使得增加、减少机器非常方便，可以实现自动运维；</p>
<p>·&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;高性能：无论是针对整个集群还是单台服务器，都要求分布式系统具备高性能；</p>
<p>·&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;易用：分布式存储系统需要能够提供易用的对外接口；另外，也要求具备完善的监控、运维工具，并能方便的与其他系统集成，如从Hadoop云计算系统导入数据；</p>
<p><strong>挑战</strong>：在于数据、状态信息的持久化，要求在自动迁移、自动容错、并发读写的过程中保证数据的一致性；</p>
<p><strong>&nbsp;2、CAP理论</strong></p>
<p>来自Berkerly的Eric Brewer教授提出了一个著名的CAP理论：一致性(Consistency)，可用性(Availability)和分区容忍性(Tolerance of networkPartition)三者不能同时满足：</p>
<p>·&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;C：读操作总是能读取到之前完成的写操作结果，满足这个条件的系统成为强一致系统，这里的“之前”一般对同一个客户端而言；</p>
<p>·&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;A：读写操作在单台机器发生故障的情况下依然能够正常执行，而不需要等待发生故障的机器重启或者其上的服务迁移到其他机器；</p>
<p>·&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;P：机器故障、网络故障、机房停电等异常情况下仍然能够满足一致性和可用性；</p>
<p>分布式存储系统要求能够自动容错，即分区可容忍性总是需要满足的，因此，一致性和写操作的可用性就不能同时满足了，需要在这二者间权衡，是选择不允许丢失数据，保持强一致，还是允许少量数据丢失以获得更好的可用性；</p>
<h2><strong>3、常见的分布式文件系统介绍</strong></h2>
<p><strong>GFS（Google File System）：</strong>Google公司为了满足本公司需求而开发的基于Linux的专有分布式文件系统。由于其元数据是存储在内存中，所以在存储文件数量上注定不可能达到海量存储，主要是存储大文件使用。</p>
<p><strong>HDFS （Hadoop Distributed File System）：</strong>Hadoop的重要组成之一，几乎完全山寨GFS</p>
<p>TFS:淘宝自主研发，将元数据存储于关系型数据库或其它高性能存储中，从而能维护海量文件元数据；主要用于存储海量小文件，维护难度大</p>
<p><strong>GlusterFS:</strong>去中心化的设计模式；擅长处理单个大文件</p>
<p><strong>Ceph：</strong>Linux内核级实现的文件系统，而已经被直接收录进Linux内核；bug较多，稳定性不佳</p>
<p><strong>MooseFS：</strong>持FUSE，相对比较轻量级，对master服务器有单点依赖，用perl编写，性能相对较差，国内用的人比较多</p>
<p><strong>MogileFS：</strong>元数据放在数据库中，擅长处理海量小文件，性能较好</p>
<p><strong>FastDFS：</strong>轻量级分布式系统，擅长处理海量小文件</p>
<p>备注：此处介绍不是很详细，如果需要详细了解，可以参考百度百科</p>
<p><strong>4、MogileFS详细介绍</strong></p>
<h2>4、1 MogileFS组成</h2>
<p><strong>MogileFS组成的三个组件：</strong></p>
<p>tracker：追踪元数据&nbsp;&nbsp; 元数据访问路由器</p>
<p>database：存储元数据</p>
<p>storage：存储数据</p>
<p><strong>traker：</strong></p>
<p>mogilefsd（守护进程），它的主要职责包括：</p>
<p>replication:节点间文件的复制；</p>
<p>deletion:删除文件</p>
<p>queryworker：响应客户请求的文件元数据访问请求</p>
<p>reaper:在存储失败后将文件复制请求重新放置于队列中</p>
<p>monitor：监测主机和设备的健康状态</p>
<p><strong>database：</strong></p>
<p>存储mogilefs的元数据，一般使用MySQL; 建议使用冗余方案以保证其可用性；(MMM, MHA)</p>
<p>mogilefs专门提供了数据结构管理工具mogdbsetup；</p>
<p><strong>storage：</strong></p>
<p>mogstored（进程名），一个准备停当的mogstored节点可通过mogadm命令添加至现在的集群中；</p>
<p>存储节点需定义“设备(dev)”用作存储空间；每个“设备”在当前集群都需要通过一个惟一的DevID来标识；</p>
<p><strong>client:</strong></p>
<p>客户端用于与mogilefs建立通信，完成数据存取；</p>
<p><strong>架构拓扑如下所示：</strong></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvNkUvRkUvd0tpb0wxV093bXppN0RNV0FBRlRULWlXSm9rMTkwLmpwZw==.jpg" /></p>
<h2>4、2 MogileFS特性：</h2>
<p>(1)工作于应用层：http, nfs；</p>
<p>(2)无单点：三大组件(tracker，mogstore，database)皆可实现高可用；</p>
<p>(3)自动完成文件复制：复制的最小单位不是文件，而是class；基于不同的class，文件可以被自动的复制到多个有足够存储空间的存储节点上</p>
<p>(4)传输无需特殊协议：可以通过NFS或HTTP协议进行通信；</p>
<p>(5)名称空间：文件通过一个给定的key来确定，是一个全局的命名空间；没有目录，基于域实现文件隔离</p>
<p>(6)不共享任何数据：无需通过昂贵的SAN来共享磁盘，每个存储节点只需维护自己所属的存储设备(device)即可</p>
<p><strong>两个关键术语：</strong></p>
<p>domain:name space，命名空间</p>
<p>一个MogileFS可以有多个Domain</p>
<p>用来存放不同文件（大小、类型）</p>
<p>同一个Domain内，key必须唯一</p>
<p>不同Domain内，key可以相同</p>
<p>class:最小复制单元</p>
<p>文件属性管理器</p>
<p>定义文件存储在不同设备上的份数</p>
<h1>5、MogileFS实现</h1>
<h2>环境拓扑</h2>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvNkYvMDIvd0tpb20xV093S19oQ2hyMUFBSldGN3I1WEtNMTA5LmpwZw==.jpg" /></p>
<p><strong>IP地址配置情况：</strong></p>
<p>Node1：IP172.16.4.100</p>
<p>Node2：IP172.16.4.101</p>
<p>Node3：IP172.16.4.102</p>
<p>系统环境：</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;cat/etc/redhat-release
CentOS&nbsp;release&nbsp;6.6&nbsp;(Final)
[[email&#160;protected]&nbsp;~]#&nbsp;uname&nbsp;-r
2.6.32-504.el6.x86_64
[[email&#160;protected]&nbsp;~]#&nbsp;uname&nbsp;-m
x86_64</pre>
<h2>5、1 Node1配置Mariadb（过程略）</h2>
<p>Mariadb配置root用户允许远程连接</p>
<pre>MariaDB&nbsp;[(none)]&gt;&nbsp;GRANT&nbsp;ALL&nbsp;ON&nbsp;*.*&nbsp;TO‘root‘@‘172.16.%.%‘&nbsp;IDENTIFIED&nbsp;BY&nbsp;‘mogilefs‘&nbsp;WITH&nbsp;GRANT&nbsp;OPTION；
MariaDB&nbsp;[(none)]&gt;&nbsp;FLUSH&nbsp;PRIVILEGES;</pre>
<h2>5、2 Node1配置tracker</h2>
<p>安装如下软件包，虽然只是配置tracker，但还是安装了storage的包，是因为后面做高可用时用到</p>
<pre>MogileFS-Server-2.46-2.el6.noarch.rpm&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#通行组件
MogileFS-Server-mogilefsd-2.46-2.el6.noarch.rpm&nbsp;&nbsp;#traker
MogileFS-Server-mogstored-2.46-2.el6.noarch.rpm&nbsp;&nbsp;#storage
MogileFS-Utils-2.19-1.el6.noarch.rpm&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#工具包
perl-MogileFS-Client-1.14-1.el6.noarch.rpm&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#客户端开发使用
perl-Net-Netmask-1.9015-8.el6.noarch.rpm&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#机架感知能力
perl-Perlbal-1.78-1.el6.noarch.rpm&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#依赖包</pre>
<p>安装命令如下</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;yum&nbsp;--nogpgcheck&nbsp;localinstall&nbsp;*.rpm</pre>
<p>由于node1是做tracker的，用到的主要程序包是MogileFS-Server-mogilefsd，其他和配置tracker没有太大关系，MogileFS-Server-mogilefsd生成的主要文件</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;rpm&nbsp;-ql&nbsp;MogileFS-Server-mogilefsd
/etc/mogilefs/mogilefsd.conf&nbsp;&nbsp;&nbsp;&nbsp;#主配置文件
/etc/rc.d/init.d/mogilefsd&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#启动脚本
/usr/bin/mogdbsetup&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#数据库初始化工具
/usr/bin/mogilefsd&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#mogilefsd主进程</pre>
<p>初始化MogileFS数据库：使用可以连接到Mariadb的用户和密码，创建一个MogileFS使用的数据库和数据库的管理用户以及设置密码</p>
<pre>&nbsp;[[email&#160;protected]~]#&nbsp;mogdbsetup&nbsp;--dbhost=172.16.4.100&nbsp;--dbrootuser=root&nbsp;--dbrootpass=mogilefs&nbsp;&nbsp;--dbname=mogdb&nbsp;--dbuser=moguser--dbpass=mogpass
&nbsp;
This&nbsp;will&nbsp;attempt&nbsp;to&nbsp;setup&nbsp;or&nbsp;upgrade&nbsp;your&nbsp;MogileFSdatabase.
It&nbsp;won‘t&nbsp;destroy&nbsp;existing&nbsp;data.
Run&nbsp;with&nbsp;--help&nbsp;for&nbsp;more&nbsp;information.&nbsp;&nbsp;Run&nbsp;with&nbsp;--yes&nbsp;to&nbsp;shut&nbsp;up&nbsp;these&nbsp;prompts.
&nbsp;
Continue?&nbsp;[N/y]:&nbsp;y
&nbsp;
Create/Upgrade&nbsp;database&nbsp;name&nbsp;‘mogdb‘?&nbsp;[Y/n]:&nbsp;y
&nbsp;
Grant&nbsp;all&nbsp;privileges&nbsp;to&nbsp;user&nbsp;‘moguser‘,&nbsp;connectingfrom&nbsp;anywhere,&nbsp;to&nbsp;the&nbsp;mogilefs&nbsp;database&nbsp;‘mogdb‘?&nbsp;[Y/n]:&nbsp;y</pre>
<p>补充：可以使用 --yes选项回答各种询问为yes。</p>
<p>验证初始化Mariadb：登录数据库查看mogdb数据库自动创建，而且库中自动创建了一些表</p>
<pre>MariaDB&nbsp;[(none)]&gt;&nbsp;show&nbsp;databases;
+--------------------+
|&nbsp;Database&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
+--------------------+
|&nbsp;information_schema&nbsp;|
|&nbsp;mogdb&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
|&nbsp;mysql&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
|&nbsp;performance_schema&nbsp;|
|&nbsp;test&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
+--------------------+
5&nbsp;rows&nbsp;in&nbsp;set&nbsp;(0.01&nbsp;sec)
&nbsp;
MariaDB&nbsp;[(none)]&gt;&nbsp;use&nbsp;mogdb;
Database&nbsp;changed
MariaDB&nbsp;[mogdb]&gt;&nbsp;show&nbsp;tables;
+----------------------+
|&nbsp;Tables_in_mogdb&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
+----------------------+
|&nbsp;checksum&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
|&nbsp;class&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
|&nbsp;device&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
|&nbsp;domain&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
|&nbsp;file&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
|&nbsp;file_on&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
|&nbsp;file_on_corrupt&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
|&nbsp;file_to_delete&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
|&nbsp;file_to_delete2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
|&nbsp;file_to_delete_later&nbsp;|
|&nbsp;file_to_queue&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
|&nbsp;file_to_replicate&nbsp;&nbsp;&nbsp;&nbsp;|
|&nbsp;fsck_log&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
|&nbsp;host&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
|&nbsp;server_settings&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
|&nbsp;tempfile&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
|&nbsp;unreachable_fids&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|
+----------------------+</pre>
<p>修改mogilefsd.conf文件设置连接Mariadb的用户名和密码，mogilefsd监听的地址和端口，启用的一些线程</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;vim&nbsp;/etc/mogilefs/mogilefsd.conf
db_dsn&nbsp;=&nbsp;DBI:mysql:mogdb:host=172.16.4.100&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#DBI：perl连接mysql的驱动，mysql数据库类型，mogdb连接的数据库，host不解释
db_user&nbsp;=&nbsp;moguser&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#连接数据库的用户
db_pass&nbsp;=&nbsp;mogpass&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#连接数据库的密码
listen&nbsp;=&nbsp;172.16.4.100:7001&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#mogilefsd监听的地址
conf_port&nbsp;=&nbsp;7001&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#监听的端口
query_jobs&nbsp;=&nbsp;10&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#启用的请求线程，为10表示只能并发10个客户端；注意客户端不是用户访问量，而是连接使用mogilefsd的服务器
delete_jobs&nbsp;=&nbsp;1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#用于删除的线程
replicate_jobs&nbsp;=&nbsp;5&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#用于作复制的线程数量
reaper_jobs&nbsp;=&nbsp;1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#在存储失败后将文件复制请求重新放置于队列中的线程</pre>
<p>设置完成启动服务并验证7001端口已经启动</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;service&nbsp;mogilefsd&nbsp;start
[[email&#160;protected]&nbsp;~]#&nbsp;netstat&nbsp;-lntp&nbsp;|&nbsp;grep&nbsp;7001
tcp&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;172.16.4.100:7001&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.0.0.0:*&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;LISTEN&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;39558/mogilefsd</pre>
<h2>5、3 node2配置storage</h2>
<p>安装如下软件包，配置storage主要用到的软件包是MogileFS-Server-mogstored</p>
<pre>MogileFS-Server-2.46-2.el6.noarch.rpm&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#通用组件
MogileFS-Server-mogilefsd-2.46-2.el6.noarch.rpm&nbsp;&nbsp;#tracker
MogileFS-Server-mogstored-2.46-2.el6.noarch.rpm&nbsp;&nbsp;#storage
MogileFS-Utils-2.19-1.el6.noarch.rpm&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#工具包
perl-MogileFS-Client-1.14-1.el6.noarch.rpm&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#客户端开发使用
perl-Net-Netmask-1.9015-8.el6.noarch.rpm&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#机架感知能力
perl-Perlbal-1.78-1.el6.noarch.rpm&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#依赖包</pre>
<p>安装命令如下</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;yum&nbsp;--nogpgcheck&nbsp;localinstall&nbsp;*.rpm</pre>
<p>Mogstored依赖与perl-IO-AIO这个包，需要额外安装，否则mogstored无法正常启动</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;yum&nbsp;-y&nbsp;install&nbsp;perl-IO-AIO</pre>
<p>MogileFS-Server-mogstored生成的文件</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;rpm&nbsp;-ql&nbsp;MogileFS-Server-mogstored
/etc/mogilefs/mogstored.conf&nbsp;&nbsp;&nbsp;&nbsp;#主配置文件
/etc/rc.d/init.d/mogstored&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#脚本文件
/usr/bin/mogautomount&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#自动挂载的工具
/usr/bin/mogstored&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#主程序</pre>
<p>创建一个目录准备存储文件，并且设置属主和属组为mogilefs，否则tracker节点会无法读取数据</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mkdir&nbsp;/mogstore
[[email&#160;protected]&nbsp;~]#&nbsp;chown&nbsp;-R&nbsp;mogilefs.mogilefs/mogstore/</pre>
<p>将存储目录挂载到单独的分区</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;vim&nbsp;/etc/fstab
/dev/sda4&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/mogstore&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ext4&nbsp;&nbsp;&nbsp;&nbsp;defaults&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;0
[[email&#160;protected]&nbsp;~]#&nbsp;mount&nbsp;-a
[[email&#160;protected]&nbsp;~]#&nbsp;mount
/dev/sda4&nbsp;on&nbsp;/mogstore&nbsp;type&nbsp;ext4&nbsp;(rw)</pre>
<p>在存储目录创建设备编号目录，注意此目录各个节点不能重名</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mkdir&nbsp;/mogstore/dev2</pre>
<p>修改配置文件</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;vim&nbsp;/etc/mogilefs/mogstored.conf
maxconns&nbsp;=&nbsp;10000&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#最大并发连接数
httplisten&nbsp;=&nbsp;0.0.0.0:7500&nbsp;&nbsp;&nbsp;&nbsp;#http协议监听的端口
mgmtlisten&nbsp;=&nbsp;0.0.0.0:7501&nbsp;&nbsp;&nbsp;&nbsp;#管理监听的端口
docroot&nbsp;=&nbsp;/mogstore&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#文件存储的目录</pre>
<p>设置完成启动服务，并验证端口是否正常启动</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;service&nbsp;mogstored&nbsp;start
[[email&#160;protected]&nbsp;~]#&nbsp;netstat&nbsp;-lntp&nbsp;|&nbsp;egrep"7500|7501"
tcp&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;0.0.0.0:7500&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.0.0.0:*&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;LISTEN&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;37119/mogstored&nbsp;&nbsp;&nbsp;&nbsp;
tcp&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;0.0.0.0:7501&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.0.0.0:*&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;LISTEN&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;37119/mogstored</pre>
<h2>5、4 node3配置storage</h2>
<p>安装如下软件包</p>
<pre>MogileFS-Server-2.46-2.el6.noarch.rpm&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#通用组件
MogileFS-Server-mogilefsd-2.46-2.el6.noarch.rpm&nbsp;&nbsp;#tracker
MogileFS-Server-mogstored-2.46-2.el6.noarch.rpm&nbsp;&nbsp;#storage
MogileFS-Utils-2.19-1.el6.noarch.rpm&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#工具包
perl-MogileFS-Client-1.14-1.el6.noarch.rpm&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#客户端开发使用
perl-Net-Netmask-1.9015-8.el6.noarch.rpm&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#机架感知能力
perl-Perlbal-1.78-1.el6.noarch.rpm&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#依赖包</pre>
<p>安装命令如下</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;yum&nbsp;--nogpgcheck&nbsp;localinstall&nbsp;*.rpm</pre>
<p>Mogstored依赖与perl-IO-AIO这个包，所以需要额外安装</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;yum&nbsp;-y&nbsp;install&nbsp;perl-IO-AIO</pre>
<p>创建一个目录准备存储文件，并设置属主和属组为mogilefs</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mkdir&nbsp;/mogstore
[[email&#160;protected]&nbsp;~]#&nbsp;chown&nbsp;-R&nbsp;mogilefs.mogilefs/mogstore/</pre>
<p>将存储目录挂载到单独的分区</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;vim&nbsp;/etc/fstab
/dev/sda4&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/mogstore&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ext4&nbsp;&nbsp;&nbsp;&nbsp;defaults&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;0
[[email&#160;protected]&nbsp;~]#&nbsp;mount&nbsp;-a
[[email&#160;protected]&nbsp;~]#&nbsp;mount
/dev/sda4&nbsp;on&nbsp;/mogstore&nbsp;type&nbsp;ext4&nbsp;(rw)</pre>
<p>在存储目录创建设备编号目录，注意此目录各个节点不能重名</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mkdir&nbsp;/mogstore/dev3</pre>
<p>修改配置文件</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;vim&nbsp;/etc/mogilefs/mogstored.conf
maxconns&nbsp;=&nbsp;10000
httplisten&nbsp;=&nbsp;0.0.0.0:7500
mgmtlisten&nbsp;=&nbsp;0.0.0.0:7501
docroot&nbsp;=&nbsp;/mogstore</pre>
<p>设置完成启动服务，并验证端口是否正常启动</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;service&nbsp;mogstored&nbsp;start
[[email&#160;protected]&nbsp;~]#&nbsp;netstat&nbsp;-lntp&nbsp;|&nbsp;egrep"7500|7501"
tcp&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;0.0.0.0:7500&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.0.0.0:*&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;LISTEN&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;37119/mogstored&nbsp;&nbsp;&nbsp;&nbsp;
tcp&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;0.0.0.0:7501&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.0.0.0:*&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;LISTEN&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;37119/mogstored</pre>
<h2><strong>5、5 配置分布式集群</strong></h2>
<p>查看MogileFS-Utils生成的命令，只列出常用的命令</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;rpm&nbsp;-ql&nbsp;MogileFS-Utils
/usr/bin/mogadm&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#MogileFS管理工具，可以实现将mogstored加入到mogilefsd
/usr/bin/mogdelete&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#删除文件
/usr/bin/mogfetch&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#获取文件
/usr/bin/mogfileinfo&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#查看文件
/usr/bin/mogupload&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#上传文件</pre>
<p><strong>Mogadm命令的常用功能：</strong></p>
<p>mogadm check&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; #状态检测</p>
<p>mogadm stats&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; #显示MogileFS的状态统计信息</p>
<p>mogadm host ...&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; #管理主机</p>
<p>mogadm device ...&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; #管理设备</p>
<p>mogadm domain ...&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; #管理域</p>
<p>mogadm class ...&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; #管理类</p>
<p>mogadm slave ...&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; #管理复制</p>
<p>mogadm fsck ...&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; #文件系统检查和修复</p>
<p>mogadm rebalance ...&nbsp;&nbsp; #重新均衡（MogileFS运行时间久了mogstored存储的数据量可能不一样，重新均衡一下各个节点的数据就差不多了）</p>
<p>mogadm settings ...&nbsp;&nbsp;&nbsp; #设置文件复制数</p>
<p>说明：使用mogadm –help或者man mogadm可以查看mogadm命令的详细使用说明</p>
<h3>5、5、1 添加主机</h3>
<p>向集群中添加主机，将node2和node3添加到集群中</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001host&nbsp;add&nbsp;node2&nbsp;--ip=172.16.4.101&nbsp;--status=alive
[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001host&nbsp;add&nbsp;node3&nbsp;--ip=172.16.4.102&nbsp;--status=alive</pre>
<p>add：表示添加主机</p>
<p>node2：表示主机名，这个可以随便写</p>
<p>--ip：表示添加的主机地址</p>
<p>--status=alive：表示添加之后的状态为上线</p>
<p>添加完成查看主机列表已经有了主机</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001host&nbsp;list
node2&nbsp;[1]:&nbsp;alive
&nbsp;&nbsp;IP:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;172.16.4.101:7500
&nbsp;
node3&nbsp;[2]:&nbsp;alive
&nbsp;&nbsp;IP:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;172.16.4.102:7500</pre>
<h3>5、5、2 添加设备</h3>
<p>节点虽然添加完成了，但是还不能存储数据，如果想存储数据需要追踪存储节点上面的设备</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001device&nbsp;add&nbsp;node2&nbsp;2
[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001device&nbsp;add&nbsp;node3&nbsp;3</pre>
<p>add：表示添加设备</p>
<p>Node2：节点名称，必须和添加主机时保持一致</p>
<p>2：添加的dev设备编号</p>
<p>添加完成查看device列表就已经出现了设备</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001device&nbsp;list
node2&nbsp;[1]:&nbsp;alive
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;used(G)&nbsp;&nbsp;&nbsp;&nbsp;free(G)&nbsp;&nbsp;&nbsp;total(G)&nbsp;weight(%)
&nbsp;&nbsp;&nbsp;dev2:&nbsp;&nbsp;&nbsp;alive&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.042&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27.866&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27.908&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;100
&nbsp;
node3&nbsp;[2]:&nbsp;alive
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;used(G)&nbsp;&nbsp;&nbsp;&nbsp;free(G)&nbsp;&nbsp;&nbsp;total(G)&nbsp;weight(%)
&nbsp;&nbsp;&nbsp;dev3:&nbsp;&nbsp;&nbsp;alive&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.042&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27.866&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27.908&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;100</pre>
<p>补充：一开始不小心将node3节点的设备，添加为了dev4，然后由添加了dev3，结果node3就出现了dev3和dev4两个设备</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001device&nbsp;add&nbsp;node3&nbsp;4
[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001device&nbsp;list
node2&nbsp;[1]:&nbsp;alive
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;used(G)&nbsp;&nbsp;&nbsp;&nbsp;free(G)&nbsp;&nbsp;&nbsp;total(G)&nbsp;weight(%)
&nbsp;&nbsp;&nbsp;dev2:&nbsp;&nbsp;&nbsp;alive&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.000&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.000&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.000&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;100
&nbsp;
node3&nbsp;[2]:&nbsp;alive
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;used(G)&nbsp;&nbsp;&nbsp;&nbsp;free(G)&nbsp;&nbsp;&nbsp;total(G)&nbsp;weight(%)
&nbsp;&nbsp;&nbsp;dev3:&nbsp;&nbsp;&nbsp;alive&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.042&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27.866&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27.908&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;100
&nbsp;&nbsp;&nbsp;dev4:&nbsp;&nbsp;&nbsp;alive&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.042&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27.866&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27.908&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;100</pre>
<p>删除方法：这里没有deleted命令，需要使用mark将dev4标记为dead状态就删除了</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001device&nbsp;mark&nbsp;node3&nbsp;4&nbsp;dead</pre>
<h3>5、5、3 定义domain和class</h3>
<p><strong>定义名称空间（domain）：</strong></p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001domain&nbsp;add&nbsp;images
[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001domain&nbsp;add&nbsp;conffiles
[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001domain&nbsp;list
&nbsp;domain&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;class&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;mindevcount&nbsp;&nbsp;&nbsp;replpolicy&nbsp;&nbsp;hashtype
--------------------&nbsp;---------------------------------&nbsp;------------&nbsp;-------
&nbsp;conffiles&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;default&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;MultipleHosts()&nbsp;NONE&nbsp;&nbsp;
&nbsp;
&nbsp;images&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;default&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;MultipleHosts()&nbsp;NONE</pre>
<p>domain：domain的名字</p>
<p>class：domain创建完成之后会自动创建一个class，所有的文件都存放在class中</p>
<p>mindevcount：最小复制单元；为2表示上传的文件最少存储两个副本</p>
<p>replpolicy：复制策略，MultipleHosts()表示多主机实现复制，这里不用管为默认即可</p>
<p>hashtype：class在命名时是使用哈希进行计算的，这里表示哈希算法，NONE表示没有使用哈希算法</p>
<p><strong>定义class：</strong></p>
<p>由于创建domain会自动创建class，所以会出现class</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001class&nbsp;list
&nbsp;domain&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;class&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;mindevcount&nbsp;&nbsp;&nbsp;replpolicy&nbsp;&nbsp;hashtype
--------------------&nbsp;---------------------------------&nbsp;------------&nbsp;-------
&nbsp;conffiles&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;default&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;MultipleHosts()&nbsp;NONE&nbsp;&nbsp;
&nbsp;
&nbsp;images&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;default&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;MultipleHosts()&nbsp;NONE</pre>
<p>新添加一个class</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001class&nbsp;add&nbsp;images&nbsp;nc1&nbsp;--mindevcount=2
[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001class&nbsp;list
&nbsp;domain&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;class&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;mindevcount&nbsp;&nbsp;&nbsp;replpolicy&nbsp;&nbsp;hashtype
--------------------&nbsp;---------------------------------&nbsp;------------&nbsp;-------
&nbsp;conffiles&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;default&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;MultipleHosts()&nbsp;NONE&nbsp;&nbsp;
&nbsp;
&nbsp;images&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;default&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;MultipleHosts()&nbsp;NONE&nbsp;&nbsp;
&nbsp;images&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;nc1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;MultipleHosts()&nbsp;NONE</pre>
<h2>5、6 验证分布式系统</h2>
<p>这个时候分布式文件系统就搭建好了，可以使用mogupload命令上传文件测试</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogupload--trackers=172.16.4.100:7001&nbsp;--domain=images&nbsp;--key=‘/1.jpg‘--file=‘/usr/share/backgrounds/centos_1920x1200_logoonly.jpg‘</pre>
<p>--domain=images：表示存储到images这个domain中</p>
<p>--key=‘/1.jpg‘：访问文件的URL地址</p>
<p>--file：本地上传的文件</p>
<p>查看上传文件的信息，在node1和node2这两个节点都有了文件</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogfileinfo--trackers=172.16.4.100:7001&nbsp;--domain=images&nbsp;--key=‘/1.jpg‘
-&nbsp;file:&nbsp;/1.jpg
&nbsp;&nbsp;&nbsp;&nbsp;class:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;default
&nbsp;devcount:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2
&nbsp;&nbsp;&nbsp;domain:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;images
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fid:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;key:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/1.jpg
&nbsp;&nbsp;&nbsp;length:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;57592
&nbsp;-http://172.16.4.102:7500/dev3/0/000/000/0000000002.fid
&nbsp;-http://172.16.4.101:7500/dev2/0/000/000/0000000002.fid</pre>
<p>这个时候分别访问下面的两个URL就可以出现刚刚上传的图片了</p>
<p>- http://172.16.4.102:7500/dev3/0/000/000/0000000002.fid</p>
<p>-http://172.16.4.101:7500/dev2/0/000/000/0000000002.fid</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNkUvRkUvd0tpb0wxV093bkhRcjZjX0FBSEs2M3ZpV1RNNzUzLmpwZw==.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNkYvMDIvd0tpb20xV093TFhTMG8wbkFBSEhtSDh1Wno0NjMwLmpwZw==.jpg" /></p>
<p>刚刚上传了一个图片，这次上传一个文本文件试试</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogupload--trackers=172.16.4.100:7001&nbsp;--domain=conffiles&nbsp;--key=‘/configures/fstab‘--file=‘/etc/fstab‘
[[email&#160;protected]&nbsp;~]#&nbsp;mogfileinfo&nbsp;--trackers=172.16.4.100:7001--domain=conffiles&nbsp;--key=‘/configures/fstab‘
-&nbsp;file:&nbsp;/configures/fstab
&nbsp;&nbsp;&nbsp;&nbsp;class:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;default
&nbsp;devcount:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2
&nbsp;&nbsp;&nbsp;domain:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;conffiles
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fid:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;3
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;key:&nbsp;&nbsp;&nbsp;&nbsp;/configures/fstab
&nbsp;&nbsp;&nbsp;length:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;921
&nbsp;-http://172.16.4.102:7500/dev3/0/000/000/0000000003.fid
&nbsp;-http://172.16.4.101:7500/dev2/0/000/000/0000000003.fid</pre>
<p>分别访问两个URL路径，查看文件都可以正常显示</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNkUvRkUvd0tpb0wxV093blNnbXc1MEFBSWVoRDVPQkVZMTg5LmpwZw==.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNkYvMDIvd0tpb20xV093TGFUWkJLaEFBSXRmRkRaYzdVNTcyLmpwZw==.jpg" /></p>
<p>不光可以上传文件，还可以下载文件，使用mogfetch指明domain是那个，key路径，使用file在指明下载之后存储到本地的那里即可</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogfetch--trackers=172.16.4.100:7001&nbsp;--domain=conffiles&nbsp;--key=‘/configures/fstab‘--file=‘/root/fstab‘
[[email&#160;protected]&nbsp;~]#&nbsp;ll&nbsp;/root/fstab
-rw-r--r--&nbsp;1&nbsp;root&nbsp;root&nbsp;921&nbsp;May&nbsp;27&nbsp;06:34&nbsp;/root/fstab</pre>
<h1>6、Mogilefsd高可用</h1>
<p>Node1，node2，node3这三个节点否启动mogilefsd和mogstored，使客户端无论访问那一个节点都可以获取到数据，而且replpolicy设置最少2份，计算是一台节点故障下线其他节点也可以继续提供服务。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvNkUvRkUvd0tpb0wxV093bmFnMU9WMUFBSndkYWJqX0xJNjAwLmpwZw==.jpg" /></p>
<h2>6、1 Node1配置mogstored</h2>
<p>手动安装mogstored的依赖包，如果不安装此包，启动mogstroed时端口不会正常启动</p>
<pre>&nbsp;[[email&#160;protected]~]#&nbsp;yum&nbsp;install&nbsp;perl-IO-AIO</pre>
<p>创建存储目录并挂载</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mkdir&nbsp;/mogstore
[[email&#160;protected]&nbsp;~]#&nbsp;vim&nbsp;/etc/fstab
/dev/sda4&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/mogstore&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ext4&nbsp;&nbsp;&nbsp;&nbsp;defaults&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;0
[[email&#160;protected]&nbsp;~]#&nbsp;mount&nbsp;-a
[[email&#160;protected]&nbsp;~]#&nbsp;mount
/dev/sda4&nbsp;on&nbsp;/mogstore&nbsp;type&nbsp;ext4&nbsp;(rw)</pre>
<p>创建设备目录并授权mogilefs用户</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mkdir&nbsp;/mogstore/dev1
[[email&#160;protected]&nbsp;~]#&nbsp;chown&nbsp;-R&nbsp;mogilefs.mogilefs/mogstore/</pre>
<p>修改配置文件，指定存储目录位置</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;vim&nbsp;/etc/mogilefs/mogstored.conf
maxconns&nbsp;=&nbsp;10000
httplisten&nbsp;=&nbsp;0.0.0.0:7500
mgmtlisten&nbsp;=&nbsp;0.0.0.0:7501
docroot&nbsp;=&nbsp;/mogstore</pre>
<p>启动服务</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;service&nbsp;mogstored&nbsp;start
[[email&#160;protected]&nbsp;~]#&nbsp;netstat&nbsp;-lntp&nbsp;|&nbsp;egrep"7500|7501"
tcp&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;0.0.0.0:7500&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.0.0.0:*&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;LISTEN&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;41087/mogstored&nbsp;&nbsp;&nbsp;&nbsp;
tcp&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;0.0.0.0:7501&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.0.0.0:*&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;LISTEN&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;41087/mogstored</pre>
<p>配置完成之后使用mogadm命令将自己也添加到集群中</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001host&nbsp;add&nbsp;node1&nbsp;--ip=172.16.4.100&nbsp;--status=alive
[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001host&nbsp;list
node2&nbsp;[1]:&nbsp;alive
&nbsp;&nbsp;IP:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;172.16.4.101:7500
&nbsp;
node3&nbsp;[2]:&nbsp;alive
&nbsp;&nbsp;IP:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;172.16.4.102:7500
&nbsp;
node1&nbsp;[3]:&nbsp;alive
&nbsp;&nbsp;IP:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;172.16.4.100:7500</pre>
<p>添加node1的设备到集群中</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001device&nbsp;add&nbsp;node1&nbsp;1
[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001device&nbsp;list
node2&nbsp;[1]:&nbsp;alive
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;used(G)&nbsp;&nbsp;&nbsp;&nbsp;free(G)&nbsp;&nbsp;&nbsp;total(G)&nbsp;weight(%)
&nbsp;&nbsp;&nbsp;dev2:&nbsp;&nbsp;&nbsp;alive&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.043&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27.865&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27.908&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;100
&nbsp;
node3&nbsp;[2]:&nbsp;alive
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;used(G)&nbsp;&nbsp;&nbsp;&nbsp;free(G)&nbsp;&nbsp;&nbsp;total(G)&nbsp;weight(%)
&nbsp;&nbsp;&nbsp;dev3:&nbsp;&nbsp;&nbsp;alive&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.043&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27.865&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27.908&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;100
&nbsp;
node1&nbsp;[3]:&nbsp;alive
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;used(G)&nbsp;&nbsp;&nbsp;&nbsp;free(G)&nbsp;&nbsp;&nbsp;total(G)&nbsp;weight(%)
&nbsp;&nbsp;&nbsp;dev1:&nbsp;&nbsp;&nbsp;alive&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.042&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27.866&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27.908&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;100</pre>
<p>由于node2和node3节点需要配置mogilefsd需要把node1上面的配置文件直接拷贝过去，省的node2和node3节点修改</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;scp&nbsp;/etc/mogilefs/mogilefsd.conf172.16.4.101:/etc/mogilefs/
[[email&#160;protected]&nbsp;~]#&nbsp;scp&nbsp;/etc/mogilefs/mogilefsd.conf&nbsp;172.16.4.102:/etc/mogilefs/</pre>
<h2>6、2 Node2配置mogilefsd</h2>
<p>由于node1节点已经将配置文件拷贝过来了，所以直接修改配置文件的监听地址即可，其他选项无需修改</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;vim&nbsp;/etc/mogilefs/mogilefsd.conf
listen&nbsp;=&nbsp;172.16.4.101</pre>
<p>设置完成启动服务即可</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;service&nbsp;mogilefsd&nbsp;start
[[email&#160;protected]&nbsp;~]#&nbsp;netstat&nbsp;-lnt&nbsp;|&nbsp;grep&nbsp;7001
tcp&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;172.16.4.101:7001&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.0.0.0:*&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;LISTEN</pre>
<h2>6、3 Node3配置mogilefsd</h2>
<p>同node2只需要修改监听地址</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;vim&nbsp;/etc/mogilefs/mogilefsd.conf
listen&nbsp;=&nbsp;172.16.4.102</pre>
<p>启动服务即可</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;service&nbsp;mogilefsd&nbsp;start
[[email&#160;protected]&nbsp;~]#&nbsp;netstat&nbsp;-lnt&nbsp;|&nbsp;grep&nbsp;7001
tcp&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;172.16.4.102:7001&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.0.0.0:*&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;LISTEN</pre>
<h2>6、4 验证MogileFS的高可用</h2>
<p>在三个节点各自配置好了tracker和storage之后高可用的MogileFS就配置完成了。</p>
<p>验证方法如下：无论使用mogadm连接那一个节点，都可以看到节点中包含了三个主机</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.100:7001host&nbsp;list
node2&nbsp;[1]:&nbsp;alive
&nbsp;&nbsp;IP:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;172.16.4.101:7500
&nbsp;
node3&nbsp;[2]:&nbsp;alive
&nbsp;&nbsp;IP:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;172.16.4.102:7500
&nbsp;
node1&nbsp;[3]:&nbsp;alive
&nbsp;&nbsp;IP:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;172.16.4.100:7500
&nbsp;
[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.101:7001host&nbsp;list
node2&nbsp;[1]:&nbsp;alive
&nbsp;&nbsp;IP:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;172.16.4.101:7500
&nbsp;
node3&nbsp;[2]:&nbsp;alive
&nbsp;&nbsp;IP:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;172.16.4.102:7500
&nbsp;
node1&nbsp;[3]:&nbsp;alive
&nbsp;&nbsp;IP:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;172.16.4.100:7500
&nbsp;
[[email&#160;protected]&nbsp;~]#&nbsp;mogadm&nbsp;--trackers=172.16.4.102:7001host&nbsp;list
node2&nbsp;[1]:&nbsp;alive
&nbsp;&nbsp;IP:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;172.16.4.101:7500
&nbsp;
node3&nbsp;[2]:&nbsp;alive
&nbsp;&nbsp;IP:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;172.16.4.102:7500
&nbsp;
node1&nbsp;[3]:&nbsp;alive
&nbsp;&nbsp;IP:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;172.16.4.100:7500</pre>
<p>上传文件验证，由于只是设置两个复制份数，所以上传的文件会随机出现在两个节点中。</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogupload--trackers=172.16.4.100:7001,172.16.4.101:7001,172.16.4.102:7001--domain=conffiles&nbsp;--key=‘/issue‘&nbsp;--file=‘/etc/issue‘
[[email&#160;protected]&nbsp;~]#&nbsp;mogfileinfo&nbsp;--trackers=172.16.4.100:7001,172.16.4.101:7001,172.16.4.102:7001--domain=conffiles&nbsp;--key=‘/issue‘
-&nbsp;file:&nbsp;/issue
&nbsp;&nbsp;&nbsp;&nbsp;class:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;default
&nbsp;devcount:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2
&nbsp;&nbsp;&nbsp;domain:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;conffiles
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fid:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;7
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;key:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/issue
&nbsp;&nbsp;&nbsp;length:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;103
&nbsp;-http://172.16.4.100:7500/dev1/0/000/000/0000000007.fid
&nbsp;-http://172.16.4.101:7500/dev2/0/000/000/0000000007.fid</pre>
<h1>7、使用nginx反向代理MogileFS</h1>
<p>拓扑图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvNkYvMDIvd0tpb20xV093TG55UURWTEFBSkpETjBlNHlZNjg0LmpwZw==.jpg" /></p>
<p>Nginx IP地址：172.16.4.10</p>
<p>系统环境和node节点一致</p>
<h2>7、1 安装nginx</h2>
<p>Nginx默认不支持MogileFS的配置，需要在编译nginx时指定nginx_mogilefs_module模块才可以代理MogileFS</p>
<p>nginx的mogilefs模块官方配置地址</p>
<pre>http://www.grid.net.ru/nginx/mogilefs.en.html</pre>
<p>编译安装nginx</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;useradd&nbsp;nginx
[[email&#160;protected]&nbsp;~]#&nbsp;mkdir&nbsp;/var/tmp/nginx/client&nbsp;-p
[[email&#160;protected]&nbsp;~]#&nbsp;yum&nbsp;-y&nbsp;install&nbsp;pcre-devel
[[email&#160;protected]&nbsp;~]#&nbsp;tar&nbsp;xf&nbsp;nginx-1.6.2.tar.gz&nbsp;&nbsp;&nbsp;&nbsp;
[[email&#160;protected]&nbsp;~]#&nbsp;tar&nbsp;xf&nbsp;nginx_mogilefs_module-1.0.4.tar.gz&nbsp;&nbsp;&nbsp;#编译nginx之前需要先解压出来，编译nginx的时候需要用
[[email&#160;protected]&nbsp;~]#&nbsp;cd&nbsp;nginx-1.6.2</pre>
<p>编译配置，这里需要指定MogileFS的模块位置</p>
<pre>./configure&nbsp;&nbsp;--prefix=/usr/local/nginx&nbsp;&nbsp;--sbin-path=/usr/local/nginx/sbin/nginx&nbsp;&nbsp;--conf-path=/etc/nginx/nginx.conf&nbsp;&nbsp;--error-log-path=/var/log/nginx/error.log&nbsp;&nbsp;--http-log-path=/var/log/nginx/access.log&nbsp;&nbsp;--pid-path=/var/run/nginx/nginx.pid&nbsp;&nbsp;--lock-path=/var/lock/nginx.lock&nbsp;&nbsp;--user=nginx&nbsp;&nbsp;--group=nginx&nbsp;&nbsp;--with-http_ssl_module&nbsp;&nbsp;--with-http_flv_module&nbsp;&nbsp;--with-http_stub_status_module&nbsp;&nbsp;--with-http_gzip_static_module&nbsp;&nbsp;--http-client-body-temp-path=/var/tmp/nginx/client/&nbsp;&nbsp;--http-proxy-temp-path=/var/tmp/nginx/proxy/&nbsp;&nbsp;--http-fastcgi-temp-path=/var/tmp/nginx/fcgi/&nbsp;&nbsp;--http-uwsgi-temp-path=/var/tmp/nginx/uwsgi&nbsp;&nbsp;--http-scgi-temp-path=/var/tmp/nginx/scgi&nbsp;&nbsp;&nbsp;--with-pcre--add-module=../nginx_mogilefs_module-1.0.4/&nbsp;&nbsp;&nbsp;&nbsp;#编译时一定要使用这一项指明mogilefs模块的解压目录位置
make&nbsp;&amp;&amp;&nbsp;make&nbsp;install</pre>
<p>编译完成提供nginx启动脚本</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;cat&nbsp;/etc/init.d/nginx
#!/bin/sh
#
#&nbsp;nginx&nbsp;-&nbsp;this&nbsp;script&nbsp;starts&nbsp;and&nbsp;stops&nbsp;the&nbsp;nginxdaemon
#
#&nbsp;chkconfig:&nbsp;&nbsp;-&nbsp;85&nbsp;15
#&nbsp;description:&nbsp;Nginx&nbsp;is&nbsp;an&nbsp;HTTP(S)&nbsp;server,&nbsp;HTTP(S)&nbsp;reverse&nbsp;#&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;proxy&nbsp;and&nbsp;IMAP/POP3&nbsp;proxy&nbsp;server
#&nbsp;processname:&nbsp;nginx
#&nbsp;config:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/etc/nginx/nginx.conf
#&nbsp;config:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/etc/sysconfig/nginx
#&nbsp;pidfile:&nbsp;&nbsp;&nbsp;&nbsp;/var/run/nginx.pid
&nbsp;
#&nbsp;Source&nbsp;function&nbsp;library.
.&nbsp;/etc/rc.d/init.d/functions
&nbsp;
#&nbsp;Source&nbsp;networking&nbsp;configuration.
.&nbsp;/etc/sysconfig/network
&nbsp;
#&nbsp;Check&nbsp;that&nbsp;networking&nbsp;is&nbsp;up.
[&nbsp;"$NETWORKING"&nbsp;=&nbsp;"no"&nbsp;]&amp;&amp;&nbsp;exit&nbsp;0
&nbsp;
nginx="/usr/local/nginx/sbin/nginx"
prog=$(basename&nbsp;$nginx)
&nbsp;
NGINX_CONF_FILE="/etc/nginx/nginx.conf"
&nbsp;
[&nbsp;-f&nbsp;/etc/sysconfig/nginx&nbsp;]&nbsp;&amp;&amp;&nbsp;./etc/sysconfig/nginx
&nbsp;
lockfile=/var/lock/subsys/nginx
&nbsp;
make_dirs()&nbsp;{
&nbsp;&nbsp;&nbsp;#&nbsp;make&nbsp;required&nbsp;directories
&nbsp;&nbsp;user=`nginx&nbsp;-V&nbsp;2&gt;&amp;1&nbsp;|&nbsp;grep&nbsp;"configure&nbsp;arguments:"&nbsp;|&nbsp;sed‘s/[^*]*--user=\([^&nbsp;]*\).*/\1/g‘&nbsp;-`
&nbsp;&nbsp;options=`$nginx&nbsp;-V&nbsp;2&gt;&amp;1&nbsp;|&nbsp;grep&nbsp;‘configure&nbsp;arguments:‘`
&nbsp;&nbsp;&nbsp;for&nbsp;opt&nbsp;in$options;&nbsp;do
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;[`echo&nbsp;$opt&nbsp;|&nbsp;grep&nbsp;‘.*-temp-path‘`&nbsp;];&nbsp;then
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;value=`echo&nbsp;$opt&nbsp;|&nbsp;cut&nbsp;-d&nbsp;"="&nbsp;-f&nbsp;2`
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if[&nbsp;!&nbsp;-d&nbsp;"$value"&nbsp;];&nbsp;then
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#&nbsp;echo&nbsp;"creating"&nbsp;$value
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;mkdir&nbsp;-p&nbsp;$value&nbsp;&amp;&amp;&nbsp;chown&nbsp;-R&nbsp;$user&nbsp;$value
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fi
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fi
&nbsp;&nbsp;&nbsp;done
}
&nbsp;
start()&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;[&nbsp;-x$nginx&nbsp;]&nbsp;||&nbsp;exit&nbsp;5
&nbsp;&nbsp;&nbsp;&nbsp;[&nbsp;-f$NGINX_CONF_FILE&nbsp;]&nbsp;||&nbsp;exit&nbsp;6
&nbsp;&nbsp;&nbsp;&nbsp;make_dirs
&nbsp;&nbsp;&nbsp;&nbsp;echo&nbsp;-n$"Starting&nbsp;$prog:&nbsp;"
&nbsp;&nbsp;&nbsp;&nbsp;daemon$nginx&nbsp;-c&nbsp;$NGINX_CONF_FILE
&nbsp;&nbsp;&nbsp;&nbsp;retval=$?
&nbsp;&nbsp;&nbsp;&nbsp;echo
&nbsp;&nbsp;&nbsp;&nbsp;[&nbsp;$retval-eq&nbsp;0&nbsp;]&nbsp;&amp;&amp;&nbsp;touch&nbsp;$lockfile
&nbsp;&nbsp;&nbsp;&nbsp;return$retval
}
&nbsp;
stop()&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;echo&nbsp;-n$"Stopping&nbsp;$prog:&nbsp;"
&nbsp;&nbsp;&nbsp;&nbsp;killproc$prog&nbsp;-QUIT
&nbsp;&nbsp;&nbsp;&nbsp;retval=$?
&nbsp;&nbsp;&nbsp;&nbsp;echo
&nbsp;&nbsp;&nbsp;&nbsp;[&nbsp;$retval-eq&nbsp;0&nbsp;]&nbsp;&amp;&amp;&nbsp;rm&nbsp;-f&nbsp;$lockfile
&nbsp;&nbsp;&nbsp;&nbsp;return$retval
}
&nbsp;
restart()&nbsp;{
&nbsp;&nbsp;&nbsp;configtest&nbsp;||&nbsp;return&nbsp;$?
&nbsp;&nbsp;&nbsp;&nbsp;stop
&nbsp;&nbsp;&nbsp;&nbsp;sleep&nbsp;1
&nbsp;&nbsp;&nbsp;&nbsp;start
}
&nbsp;
reload()&nbsp;{
&nbsp;&nbsp;&nbsp;configtest&nbsp;||&nbsp;return&nbsp;$?
&nbsp;&nbsp;&nbsp;&nbsp;echo&nbsp;-n$"Reloading&nbsp;$prog:&nbsp;"
&nbsp;&nbsp;&nbsp;&nbsp;killproc$nginx&nbsp;-HUP
&nbsp;&nbsp;&nbsp;&nbsp;RETVAL=$?
&nbsp;&nbsp;&nbsp;&nbsp;echo
}
&nbsp;
force_reload()&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;restart
}
&nbsp;
configtest()&nbsp;{
&nbsp;&nbsp;$nginx&nbsp;-t-c&nbsp;$NGINX_CONF_FILE
}
&nbsp;
rh_status()&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;status$prog
}
&nbsp;
rh_status_q()&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;rh_status&gt;/dev/null&nbsp;2&gt;&amp;1
}
&nbsp;
case&nbsp;"$1"&nbsp;in
&nbsp;&nbsp;&nbsp;&nbsp;start)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;rh_status_q&nbsp;&amp;&amp;&nbsp;exit&nbsp;0
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$1
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;;;
&nbsp;&nbsp;&nbsp;&nbsp;stop)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;rh_status_q&nbsp;||&nbsp;exit&nbsp;0
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$1
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;;;
&nbsp;&nbsp;&nbsp;restart|configtest)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$1
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;;;
&nbsp;&nbsp;&nbsp;&nbsp;reload)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;rh_status_q&nbsp;||&nbsp;exit&nbsp;7
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$1
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;;;
&nbsp;&nbsp;&nbsp;force-reload)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;force_reload
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;;;
&nbsp;&nbsp;&nbsp;&nbsp;status)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;rh_status
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;;;
&nbsp;&nbsp;&nbsp;condrestart|try-restart)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;rh_status_q&nbsp;||&nbsp;exit&nbsp;0
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;;;
&nbsp;&nbsp;&nbsp;&nbsp;*)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo$"Usage:&nbsp;$0{start|stop|status|restart|condrestart|try-restart|reload|force-reload|configtest}"
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;exit2
esac</pre>
<p>设置执行权限，并加入服务列表</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;chmod&nbsp;+x&nbsp;/etc/rc.d/init.d/nginx
[[email&#160;protected]&nbsp;~]#&nbsp;chkconfig&nbsp;--add&nbsp;nginx</pre>
<p>启动nginx服务</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;service&nbsp;nginx&nbsp;start
[[email&#160;protected]&nbsp;~]#&nbsp;netstat&nbsp;-lntp&nbsp;|&nbsp;grep&nbsp;80
tcp&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;0.0.0.0:80&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0.0.0.0:*&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;LISTEN&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;8841/nginx</pre>
<h2>7、2 设置反向代理</h2>
<p>修改nginx配置文件添加一个location</p>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;location&nbsp;/images/&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;mogilefs_tracker172.16.4.100:7001;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;mogilefs_domainimages;
&nbsp;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;mogilefs_pass&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;proxy_pass$mogilefs_path;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;proxy_hide_header&nbsp;Content-Type;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;proxy_buffering&nbsp;off;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}</pre>
<p>设置完成重启服务，配置生效</p>
<p>向存储中上传文件</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogupload&nbsp;--trackers=172.16.4.100:7001&nbsp;--domain=images--key="2.jpg"&nbsp;--file="/root/2.jpg"
[[email&#160;protected]&nbsp;~]#&nbsp;mogfileinfo&nbsp;--trackers=172.16.4.100:7001--domain=images&nbsp;--key="2.jpg"
-&nbsp;file:&nbsp;2.jpg
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;class:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;default
&nbsp;&nbsp;devcount:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2
&nbsp;&nbsp;&nbsp;&nbsp;domain:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;images
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fid:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;8
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;key:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2.jpg
&nbsp;&nbsp;&nbsp;&nbsp;length:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;150255
&nbsp;-http://172.16.4.100:7500/dev1/0/000/000/0000000008.fid
&nbsp;-http://172.16.4.102:7500/dev3/0/000/000/0000000008.fid</pre>
<p>使用nginx访问/images/下的2.jpg，就可以看到刚刚上传的2.jpg文件</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNkYvMDIvd0tpb20xV093TDNSOUZXNEFBSTRCdWNrclQ0NTQwLmpwZw==.jpg" /></p>
<h2>7、3 设置负载均衡</h2>
<p>由于后端有3个tracker服务器，所以可以使用nginx的upstream实现负载均衡，配置方法如下所示：</p>
<pre>&nbsp;&nbsp;upstream&nbsp;mogtrackers&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;server&nbsp;172.16.4.100:7001;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;server172.16.4.101:7001;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;server172.16.4.102:7001;
&nbsp;&nbsp;&nbsp;&nbsp;}
&nbsp;
server&nbsp;{
&nbsp;省略内容……
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;location&nbsp;/images/&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;mogilefs_tracker&nbsp;mogtrackers;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;mogilefs_domain&nbsp;images;
&nbsp;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;mogilefs_pass&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;proxy_pass&nbsp;$mogilefs_path;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;proxy_hide_header&nbsp;Content-Type;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;proxy_buffering&nbsp;off;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 17:55:23 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/mogilefs/" title="mogilefs">mogilefs</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>MogileFS分布式文件系统的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M61mjN4.html" rel="bookmark">Nginx&plus;MogileFS分布式文件系统部署实验</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				实验要求 1.  部署mogilefs分布式文件系统 2.  nginx代理 实验环境 1.拓扑 2.网络地址规划 node1:172.16.76.10 nginx (centos6.8) node2:172.16.76.20 Trackers .storage Node   (centos7.2) node3:172.16.76.30 storage Node                   (centos7.2) node4:172.16.76.40 storage Node  (Mar			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35qjYR3.html" rel="bookmark">Mogilefs分布式文件系统-Keepalived&plus;Nginx双主模型实现图片分布式存储、访问</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.分布式文件系统: 分布式文件系统(Distributed File System)是指文件系统管理的物理存储资源不一定直接连接在本地节点上,而是通过计算机网络与节点相连.计算机通过文件系统管理.存储数据,单纯通过增加硬盘个数来扩展计算机文件系统的存储容量的方式,在容量大小.容量增长速度.数据备份.数据安全等方面的表现都差强人意. 分布式文件系统可以有效解决数据的存储和管理难题:将固定于某个地点的某个文件系统,扩展到任意多个地点/多个文件系统,众多的节点组成一个文件系统网络.每个节点可以分布在			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rzXYq3.html" rel="bookmark">分布式存储之MogileFS分布式文件系统简单应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.分布式存储原理: 分布式存储系统,是将数据分散存储在多台独立的设备上.传统的网络存储系统采用集中的存储服务器存放所有数据,存储服务器成为系统性能的瓶颈,也是可靠性和安全性的焦点,不能满足大规模存储应用的需要.分布式网络存储系统采用可扩展的系统结构,利用多台存储服务器分担存储负荷,利用位置服务器定位存储信息,它不但提高了系统的可靠性.可用性和存取效率,还易于扩展. 1.分布式文件系统的特点: • 节点间能相互通信 • 同一数据存储在多个节点上 • 数据空间平衡 • 具有容错能力 • 文件系统的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/j4NY683.html" rel="bookmark">mogilefs分布式文件系统搭建详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MogileFS是一套开源的分布式存储软件,适用于存储海量小文件.由tracker,mogstore,database三个部分组成. Tracker:它通过数据库来保存元数据信息,包括站点domain.class.host等:主要功能包括监控后端Storage节点,及指示Storage节点完成数据的添加.删除.查询,及节点之间数据的复制等. mogstored 实际存储数据的位置,默认监听在7500端口,接受客户端的文件存储请求. database:用来做数据key  value 映射,可用my			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NKQ5GM.html" rel="bookmark">Linux之使用MogileFS分布式文件系统并使用nginx实现反向代理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MogileFS是一套高效的文件自动备份组件,由Six Apart开发,广泛应用在包括LiveJournal等web2.0站点上. MogileFS的特性: 工作在应用层,无单点,自动文件复制(复制的最小单位是class,而不是文件),传输中立且使用nfs或者http协议进行传输. MogileFS的结构组成: tracker:是mogilefs的核心,是一个调度器,通过数据库来保存元信息,包括daemon,class,host等信息,主要职责:监控后端mogstore节点,并指示store节点			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0a7mmP4.html" rel="bookmark">CentOS 6&period;5 分布式文件系统之MogileFS工作原理及实现过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				   MogileFS是一套高效的文件自动备份组件,由Six Apart开发,广泛应用在包括LiveJournal等web2.0站点上.MogileFS由3个部分组成:    第1个部分:是server端,包括mogilefsd和mogstored两个程序.前者即是mogilefsd的tracker,它将一些全局信息保存在数据库里,例如站点domain,class,host等.后者即是存储节点(store node),它其实是个HTTP Daemon,默认侦听在7500端口,接受客户端的文件备份			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0j7l7W3.html" rel="bookmark">MogileFS的分布式文件系统的实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MogileFS:是一套分布式文件存储的解决方案,它不需要特殊的核心组件.无单点失败.自动的文件复制.比RAID好多了.传输中立,无特殊协议(客户端可以通过NFS或HTTP来和MogileFS通信).简单的命名空间.不用共享任何东西.不需要RAID.不会碰到文件系统本身的不可知情况 等等优点. server端由mogilefsd和mogstored两个程序组成,mogilefsd既tracker,用来存数全局元数据放在数据库中,mogstored既存储节点. 实验目的: 实现mogilefs分布			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eEOlD0.html" rel="bookmark">分布式文件系统之MogileFS工作原理及实现过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MogileFS是一套高效的文件自动备份组件,由Six Apart开发,广泛应用在包括LiveJournal等web2.0站点上.MogileFS由3个部分组成:   第1个部分:是server端,包括mogilefsd和mogstored两个程序.前者即是mogilefsd的tracker,它将一些全局信息保存在数据库里,例如站点domain,class,host等.后者即是存储节点(store node),它其实是个HTTP Daemon,默认侦听在7500端口,接受客户端的文件备份请求.在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Jjv6Q4.html" rel="bookmark">分布式文件系统 ~MogileFS~</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  一.分布式文件系统 分布式文件系统(Distributed File System)是指文件系统管理的物理存储资源不一定直接连接在本地节点上,而是通过计算机网络与节点相连,也就是集群文件系统,可以支持大数量的节点以及PB级的数量存储.相对地,在一个分享的磁盘文件系统中,所有节点对数据存储区块都有相同的访问权,在这样的系统中,访问权限就必须由客户端程序来控制.分布式文件系统可能包含的功能有:透通的数据复制与容错.也就是说,即使系统中有一小部份的节点脱机,整体来说系统仍然可以持续运作而不会有数据			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/BMzLmA3.html" rel="bookmark" class="title">vmware-CLI for linux</a>
					<div>
						修改系统的环境变量 vmware-install.pl出现的代理问题 http_proxy=XXXXX ftp_proxy=XXXXX 将http.ftp环境变量加入到bashrc或者profile中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9MEAByM.html" rel="bookmark" class="title">oc-15-匿名对象</a>
					<div>
						/** 匿名对象 1.访问成员变量---&gt;只能给成员变量设置值,只能成功1次,每次都是新的对象. 2.调用方法时类似类方法: 跟类方法区别:匿名对象创建对象了,开辟空间了. */ #import ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NJ7k64.html" rel="bookmark" class="title">权限管理系统 用户信息 --MyRapid 快速开发框架  Winform</a>
					<div>
						1.1.2 用户信息 用户信息对用户信息进行登记,对于权限管理来说,这里只有用户编号具有意义,权限系统根据用户编号进行用户识别绑定.其他信息,例如:权限.部门.帐号类型等是框架所需要用到的属性,并不涉 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mml1NB4.html" rel="bookmark" class="title">【2-SAT】HDU3622-Bomb Game</a>
					<div>
						[题目大意] 给n对炸弹可以放置的位置(每个位置为一个二维平面上的点),每次放置炸弹是时只能选择这一对中的其中一个点,每个炸弹爆炸的范围半径都一样,控制爆炸的半径使得所有的爆炸范围都不相交(可以相切) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NzjP84.html" rel="bookmark" class="title">二维数组的认识及其表示元素的两种方式</a>
					<div>
						/* ============================================================================ Name : TeatArr.c Aut ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/418Jyq3.html" rel="bookmark" class="title">排序算法《3》插入排序</a>
					<div>
						算法实现: 使用插入排序将下面的数字按照从小到大的顺序排列 2 9 5 4 8 1 6 步骤1:数组中已经排好的是{1},将9插入数组中 步骤2:数组中已经排好的是{2,9},将5插入数组中 步骤3: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YXYyJM.html" rel="bookmark" class="title">&lbrack;转&rsqb;学习你的第一门编程语言</a>
					<div>
						学习你的第一门编程语言 投递人 itwriter 发布于 2016-11-04 12:24 评论(0) 有539人阅读 原文链接 [收藏] ? ? 英文原文:Learning Your First P ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YXYZrM.html" rel="bookmark" class="title">oracle 断电后ORA-600处理</a>
					<div>
						因断电导致oracel启动失败解决 1尝试recover database 失败 2.创建控制文件 sql&gt;alter database backup controlfile to trace  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDo8mp4.html" rel="bookmark" class="title">LA UVaLive 7375 Hilbert Sort &lpar;递归，四分图，模拟&rpar;</a>
					<div>
						题意:告诉你一条希尔伯特曲线的大小,然后给你n 个人,及n 个人的坐标,你的起点是左下角,终点是右下角,按照希尔伯特的曲线去走,按照这个顺序给n个人排序, 按顺序输出每个人的名字! 析:这就是一个四分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bgzwY3.html" rel="bookmark" class="title">uva 10129 play on words&mdash;&mdash;yhx</a>
					<div>
						把每个字母看成一个结点,每个单词看成一条从第一个字母到最后一个字母的有向边.把这些单词首尾相接相当于寻找欧拉路径(一笔画). 则其需满足两个条件:1.忽略边的方向后,原图联通.2.一个点的入度比出度大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e7EoJ4.html" rel="bookmark" class="title">Python 中文编码</a>
					<div>
						Python中默认的编码格式是 ASCII 格式,在没修改编码格式时无法正确打印汉字,所以在读取中文时会报错. 解决方法为只要在文件开头加入 # -*- coding: UTF-8 -*- 或者 #c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QwoAE0.html" rel="bookmark" class="title">java Date和Calendar类</a>
					<div>
						最近在无聊的看书,遇到一编程题目,问题描述如下: 黑色星期五源于西方迷信:耶稣基督死于星期五,而13也是一个不吉利的数字.黑色星期五即该日同时是星期五又是13号,求未来几年内这样的日子. 基于该问题会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e7L1J4.html" rel="bookmark" class="title">match&lowbar;parent、wrap&lowbar;parent、具体值 和 MeasureSpec 类中  mode 的对应关系</a>
					<div>
						测试结果如下: * wrap_parent -&gt; MeasureSpec.AT_MOST * match_parent -&gt; MeasureSpec.EXACTLY * 具体值 -&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZbvXJ3.html" rel="bookmark" class="title">2014年暑假总结</a>
					<div>
						概述 时间过得真快啊,不知不觉半年又过去了,这半年发生的事不是太多,但是,每一件事又都是那么的刻骨铭心 学到的技术 java java学习的不是太多,主要有总结了一下之前的j2se,学习了j2ee的理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lkDkNM.html" rel="bookmark" class="title">C&plus;&plus;的标准模板库STL中实现的数据结构之顺序表vector的分析与使用</a>
					<div>
						摘要 本文主要借助对C++的标准模板库STL中实现的数据结构的学习和使用来加深对数据结构的理解.即联系数据结构的理论分析和详细的应用实现(STL),本文是系列总结的第一篇,主要针对线性表中的顺序表(动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ko8Z70.html" rel="bookmark" class="title">。。。事件注册方法之五。。。</a>
					<div>
						在MainActivity.java文件中,定义另外一个自定义的类: 在MainActivity.java中定义控件对象: 然后通过定义自定义类的对象,将事件对象传入到事件方法中: 通过将MainAc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGdO6y0.html" rel="bookmark" class="title">centos 删除默认路由</a>
					<div>
						描述: 虚拟机安装了centos,安装时网络配置为固定ip,系统安装好后又增加了一个网卡口,并定位为桥接模式,而原网卡则变更为DHCP方式获取ip地址,同时作为公网出口. 问题来了,网卡配置都正确,同 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rBOAw3.html" rel="bookmark" class="title">ThinkPHP中的快捷函数小结</a>
					<div>
						U() 制作url地址的快捷函数 C(名称) 获得配置变量(convertion.php config.php)信息C(名称,值) 设置配置变量信息 L() 获得语言变量信息E() 给页面输出错误信息 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDNbD73.html" rel="bookmark" class="title">linux命令 wget</a>
					<div>
						Linux系统中的wget是一个下载文件的工具,它用在命令行下.对于Linux用户是必不可少的工具,我们经常要下载一些软件或从远程服务器恢复备份到本地服务器.wget支持HTTP,HTTPS和FTP协 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49kgbb0.html" rel="bookmark" class="title">thinkphp笔记-创建数据</a>
					<div>
						这段代码看不懂.-&lt;thinkphph3.2.3快速入门&gt; &lt;?phpnamespace Home\Controller;use Think\Controller;class For ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
